"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypegooseQueryServiceProviders = void 0;
const core_1 = require("@nestjs-query/core");
const nestjs_typegoose_1 = require("nestjs-typegoose");
const mongoose_1 = require("mongoose");
const services_1 = require("./services");
core_1.AssemblerSerializer((obj) => obj.toObject({ virtuals: true }))(mongoose_1.Document);
function createTypegooseQueryServiceProvider(model) {
    return {
        provide: core_1.getQueryServiceToken(model),
        useFactory(ModelClass) {
            // initialize default serializer for documents, this is the type that mongoose returns from queries
            // eslint-disable-next-line @typescript-eslint/no-unsafe-return
            core_1.AssemblerSerializer((obj) => obj.toObject({ virtuals: true }))(ModelClass);
            return new services_1.TypegooseQueryService(ModelClass);
        },
        inject: [nestjs_typegoose_1.getModelToken(model.name)],
    };
}
const createTypegooseQueryServiceProviders = (models) => models.map((model) => createTypegooseQueryServiceProvider(model));
exports.createTypegooseQueryServiceProviders = createTypegooseQueryServiceProviders;
//# sourceMappingURL=providers.js.map